import {
  createSelector,
  MemoizedSelector,
} from '@ngrx/store';

import { RPCClientError } from '@loafer/ng-rpc/protocol';

import { Infra } from '../../model';
import { Page } from '../../../../app/commons/model';

export interface State {
  error: RPCClientError | null;
  isPending: boolean;
  page: Page | null;
}

export const initialState: State = {
  error: null,
  isPending: false,
  page: null,
};

export class StateSelector {
  public constructor(private _selector: MemoizedSelector<any, any>) {
  }

  public getInfraList = createSelector(this._selector, (state: State) => state.page);
  public getError = createSelector(this._selector, (state: State) => state.error);
  public isPending = createSelector(this._selector, (state: State) => state.isPending);
}
