import {
  createSelector,
  createFeatureSelector,
  ActionReducerMap,
  Selector,
} from '@ngrx/store';

import { StateSelector } from 'packages/core/ngrx/store';

import { MODULE } from '../member.constant';

import * as AuthStore from './auth';
import * as SignupStore from './signup';

export interface State {
  auth: AuthStore.State;
  signup: SignupStore.Signup;
}

export const REDUCERS = {
  auth: AuthStore.reducer,
  signup: SignupStore.reducer,
};

export const EFFECTS = [
  AuthStore.Effects,
  SignupStore.Effects,
];

export const selectMemberState = createFeatureSelector<State>(MODULE.name);

export const AuthSelector = new StateSelector<AuthStore.State>(createSelector(
  selectMemberState,
  (state: State) => state.auth
));

export const SignupSelector = new StateSelector<SignupStore.Signup>(createSelector(
  selectMemberState,
  (state: State) => state.signup
));
