import { RPCClientError } from '@loafer/ng-rpc/protocol';

import { Probe } from '../../model';

export interface State {
  error: RPCClientError | null;
  isPending: boolean;
  probes: Probe[] | null;
}

export const initialState: State = {
  error: null,
  isPending: false,
  probes: null,
};

export const getProbes = (state: State) => state.probes;
export const getError = (state: State) => state.error;
export const isPending = (state: State) => state.isPending;
