import { Component, OnInit } from '@angular/core';
import { AfterContentInit } from '@angular/core/src/metadata/lifecycle_hooks';
import {FormsModule} from '@angular/forms';

export class SensorItemResult {
  id?: number;
  sensorItemName?: String;
  sensorItemUnit?: String;
  sensorKeyName?: String;
}


@Component({
  selector: 'of-sensor-setting-result',
  templateUrl: './setting-result.component.html',
  styleUrls: ['./setting-result.component.scss']
})
export class SettingResultComponent implements OnInit, AfterContentInit {

  selectInterval: string;
  sensorItemResultList: Array<SensorItemResult>;
  optionList: Array<number>;

  constructor() { }

  intervals = [
    '600',
    '400',
    '200',
  ];

  ngAfterContentInit() {

    this.sensorItemResultList = new Array();
    this.optionList = new Array();

    const ctu: SensorItemResult = {
      id: 1,
      sensorItemName: 'CPU Total Usage',
      sensorItemUnit: '%',
      sensorKeyName: 'wmi.cpu.usage.total'
    };

    const cfu: SensorItemResult = {
      id: 2,
      sensorItemName: 'CPU Free Usage',
      sensorItemUnit: 'kb',
      sensorKeyName: 'wmi.cpu.usage.free'
    };

    const mtu: SensorItemResult = {
      id: 3,
      sensorItemName: 'Mem Total Usage',
      sensorItemUnit: '%',
      sensorKeyName: 'wmi.mem.usage.total'
    };

    this.sensorItemResultList.push(ctu);
    this.sensorItemResultList.push(cfu);
    this.sensorItemResultList.push(mtu);

    for ( let indexI = 0; indexI < this.sensorItemResultList.length; ++indexI) {
      this.optionList.push(this.sensorItemResultList[indexI].id);
    }

  }

  ngOnInit() {
  }

}
