import { Component, OnInit, OnChanges, Input, Output, EventEmitter, ViewChild, AfterViewInit, OnDestroy } from '@angular/core';
import { Router } from '@angular/router';
import { Store, select } from '@ngrx/store';
import { RPCClientError } from '@loafer/ng-rpc/protocol';
import * as ListStore from 'packages/meta/sensor-display-item/store/list';
import { ReadAllSensorDisplayItemByCrawlerSelector } from 'packages/meta/sensor-display-item/store';
import { MetaSensorDisplayItem } from 'packages/meta/sensor-display-item/model/MetaSensorDisplayItem';
import { MetaCrawler } from '../../../../meta/crawler/model/MetaCrawler';
import { MetaSensorItemType } from '../../../../meta/sensor-item-type/model/MetaSensorItemType';
import { TreeNode } from 'primeng/primeng';

@Component({
  selector: 'of-sensor-item-selector',
  templateUrl: './sensor-item-selector.component.html',
  styleUrls: ['./sensor-item-selector.component.scss']
})
export class SensorItemSelectorComponent implements OnInit, OnChanges {

  @Input() selectedCrawler: MetaCrawler;
  @Output() itemSelectEvent = new EventEmitter<Set<MetaSensorDisplayItem>>();
  items$ = this.listStore.pipe(select(ReadAllSensorDisplayItemByCrawlerSelector.select('list')));

  selectedItems: MetaSensorDisplayItem[];
  treeNode: TreeNode[];

  constructor(
    private router: Router,
    private listStore: Store<ListStore.State>,
  ) { }

  ngOnInit() {
    // this.items$.subscribe(
    //   (list: MetaSensorDisplayItem[]) => {
    //     if (list !== null) {
    //     }
    //   },
    //   (error: RPCClientError) => {
    //     console.log(error.response.message);
    //   }
    // );

    // Temporary data
    const displayItems = [];
    for (let i = 0; i < 10; i++) {
      let isDefault = false;
      const t: MetaSensorItemType = {
        name: 'CPU'
      };
      if (i % 2) {
        isDefault = true;
        t.name = 'Memory';
      }
      const si: MetaSensorDisplayItem = {
        id: i,
        key: 'SensorDisplayItemKey' + i,
        displayName: 'DisplayName' + i,
        description: 'Description' + i,
        default: isDefault,
        itemType: t
      };
      displayItems.push(si);
    }

    this.generateTreeData(displayItems);
  }

  generateTreeData(items) {

  }


  ngOnChanges() {
    // this.checkedSet.clear();
    this.listStore.dispatch(new ListStore.ReadAllByCrawler(this.selectedCrawler));
  }

}
