import { Component, OnInit, Input, Inject, DoCheck, ViewEncapsulation } from '@angular/core';
import { Target } from 'packages/target/model';
import { Infra } from 'packages/infra/model';
import { MetaCrawler } from 'packages/meta/crawler/model/MetaCrawler';
import { MetaSensorDisplayItem } from 'packages/meta/sensor-display-item/model/MetaSensorDisplayItem';

import { Store, select } from '@ngrx/store';
import { RPCClientError } from '@loafer/ng-rpc/protocol';
import * as SensorItemKeyListStore from 'packages/sensor-item/store/key-list';
import { ReadSensorItemKeySelector } from 'packages/sensor-item/store';
import { MetaSensorItemKey } from 'packages/meta/sensor-item-key/model/MetaSensorItemKey';

@Component({
    selector: 'of-sensor-setting',
    templateUrl: './setting.component.html',
    encapsulation: ViewEncapsulation.None
})
export class SettingComponent implements OnInit, DoCheck {

    sensorItemKeys$ = this.keyListStore.pipe(select(ReadSensorItemKeySelector.select('list')));
    stepsItems = [
        {
            label: 'Target'
        },
        {
            label: 'Crawler'
        },
        {
            label: 'Credentials'
        },
        {
            label: 'Sensor Items'
        }
    ];
    activeIndex = 1;

    constructor(
        private keyListStore: Store<SensorItemKeyListStore.State>,
    ) {
    }

    ngOnInit() {
        this.sensorItemKeys$.subscribe(
            (list: MetaSensorItemKey[]) => {
                if (list !== null) {
                    console.log(list);
                }
            },
            (error: RPCClientError) => {
                console.log(error.response.message);
            }
        );
    }

    ngDoCheck() {
    }
}
