import {
  createSelector,
  createFeatureSelector,
  ActionReducerMap,
} from '@ngrx/store';

import { StateSelector } from 'packages/core/ngrx/store';

import { MODULE } from '../sensor.constant';

import * as ListStore from './list';
import * as RegistStore from './regist';

export interface State {
  list: ListStore.State;
  sensor: RegistStore.State;
}

export const REDUCERS = {
  list: ListStore.reducer,
  sensor: RegistStore.reducer,
};

export const EFFECTS = [
  ListStore.Effects,
  RegistStore.Effects,
];

export const sensorState = createFeatureSelector<State>(MODULE.name);

export const sensorListSelector = new StateSelector<ListStore.State>(createSelector(
  sensorState,
  (state: State) => state.list
));
export const sensorSelector = new StateSelector<RegistStore.State>(createSelector(
  sensorState,
  (state: State) => state.sensor
));

