import {
  createSelector,
  createFeatureSelector,
  ActionReducerMap,
} from '@ngrx/store';

import { StateSelector } from 'packages/core/ngrx/store';

import { MODULE } from '../member-totp.constant';

import * as TotpStore from './totp';

export interface State {
  totp: TotpStore.State;
}

export const REDUCERS = {
  totp: TotpStore.reducer,
};

export const EFFECTS = [
  TotpStore.Effects,
];

export const selectMemberTotpState = createFeatureSelector<State>(MODULE.name);

export const TotpSelector = new StateSelector<TotpStore.State>(createSelector(
  selectMemberTotpState,
  (state: State) => state.totp
));

